searchNodes=[{"doc":"This is a smart cell that can be used to add a Wardley Map to a page. Wardley Maps are a chain of needs (a value chain) plotted against an evolution axis. See https://en.wikipedia.org/wiki/Wardley_map for a description of what a wardley map is. They are typically used to discuss strategy.","ref":"Kino.Wardley.html","title":"Kino.Wardley","type":"module"},{"doc":"","ref":"Kino.Wardley.html#child_spec/1","title":"Kino.Wardley.child_spec/1","type":"function"},{"doc":"This is used to create the smart cell.","ref":"Kino.Wardley.html#new/1","title":"Kino.Wardley.new/1","type":"function"},{"doc":"This is the output used to render Wardley Maps.","ref":"KinoWardley.Output.html","title":"KinoWardley.Output","type":"module"},{"doc":"Create a wardley map. Here is a sample spec: id myid7 height 400 width 800 anchor Business [ 0.95 , 0.63 ] anchor Public [ 0.95 , 0.78 ] component Cup of Tea [ 0.79 , 0.61 ] component Cup [ 0.73 , 0.78 ] component Tea [ 0.63 , 0.81 ] component Hot Water [ 0.52 , 0.80 ] component Water [ 0.38 , 0.82 ] component Kettle [ 0.43 , 0.35 ] evolve Kettle [ 0.43 , 0.62 ] component Power [ 0.10 , 0.71 ] evolve Power [ 0.10 , 0.89 ] Business -&gt; Cup of Tea Public -&gt; Cup of Tea Cup of Tea -&gt; Cup Cup of Tea -&gt; Tea Cup of Tea -&gt; Hot Water Hot Water -&gt; Water Hot Water -&gt; Kettle Kettle -&gt; Power","ref":"KinoWardley.Output.html#new/1","title":"KinoWardley.Output.new/1","type":"function"},{"doc":"This is a livebook smart cell that contains a basic renderer for a Wardley Map","ref":"readme.html","title":"KinoWardley","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding kino_wardley to your list of dependencies in mix.exs : def deps do [ { :kino_wardley , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/kino_wardley . This is a sample wardley map that can be generated using the following code: KinoWardley.Output . new ( &quot;&quot;&quot; id myid8 height 400 width 800 title Tea Shop anchor Business [0.95, 0.63] anchor Public [0.95, 0.78] component Cup of Tea [0.79, 0.61] label [19, -4] component Cup [0.73, 0.78] component Tea [0.63, 0.81] component Hot Water [0.52, 0.80] component Water [0.38, 0.82] component Kettle [0.43, 0.35] label [-57, 4] evolve Kettle [0.43, 0.62] label [16, 7] component Power [0.1, 0.7] label [-27, 20] evolve Power [0.1, 0.89] label [-12, 21] Business-&gt;Cup of Tea Public-&gt;Cup of Tea Cup of Tea-&gt;Cup Cup of Tea-&gt;Tea Cup of Tea-&gt;Hot Water Hot Water-&gt;Water Hot Water-&gt;Kettle Kettle-&gt;Power evolution Experiment-&gt;Prototype-&gt;Production-&gt;Product &quot;&quot;&quot; ) Since large parts of this are in javascript it has a javascript test suite. The test folder has a package.json. npm run test Here is a sample livebook that can be directly opened:","ref":"readme.html#installation","title":"KinoWardley - Installation","type":"extras"},{"doc":"","ref":"syntax.html","title":"Syntax of the Kino Wardley Map","type":"extras"},{"doc":"This is the documentation that is typically missing from a component like this. It is a description of each of the options available in the mini-language. Conceptually the wardley map has a vertical axis ranging from 0 to 1 (don't use 1, the offset logic used to display will probably render the component outside of the visible area of the svg) representing visibility and a horizontal axis ranging from 0 to 1 (don't use 1) representing evolution. The code will attempt to render the supplied specification and will try to ignore input it does not recognise. Please raise an issue at the github project with sample minimal specs that break the parser. Don't get too hung up on precise placement is the general relationships that matter. The initial syntax was inspired by onlinewardleymaps.com and is largely compatible. It is now beginning to diverge, but does agree on anything used on the tea shop example. Typically KinoWardley.Output is fed a specification that looks like this: &quot;&quot;&quot; title Tea Shop anchor Business [0.95, 0.63] anchor Public [0.95, 0.78] component Cup of Tea [0.79, 0.61] label [19, -4] component Cup [0.73, 0.78] component Tea [0.63, 0.81] component Hot Water [0.52, 0.80] component Water [0.38, 0.82] component Kettle [0.43, 0.35] label [-57, 4] evolve Kettle 0.62 label [16, 7] component Power [0.1, 0.7] label [-27, 20] evolve Power 0.89 label [-12, 21] Business-&gt;Cup of Tea Public-&gt;Cup of Tea Cup of Tea-&gt;Cup Cup of Tea-&gt;Tea Cup of Tea-&gt;Hot Water Hot Water-&gt;Water Hot Water-&gt;Kettle Kettle-&gt;Power annotation 1 [[0.43,0.49],[0.08,0.79]] Standardising power allows Kettles to evolve faster annotation 2 [0.48, 0.85] Hot water is obvious and well known annotations [0.60, 0.02] note +a generic note appeared [0.23, 0.33] style wardley &quot;&quot;&quot; Each line starts with one of the keywords (listed below) or is considered a relationship. By convention keywords start with lower case letter and Components start with a Capital letter.","ref":"syntax.html#introduction","title":"Syntax of the Kino Wardley Map - Introduction","type":"extras"},{"doc":"anchor annotation annotations background component evolve evolution group height id note padding style title width anchor These are the root needs that the wardley map is anchored to. anchor Name of Anchor [ 0.95 , 0.7 ] anchor Customer [ 0.95 , 0.9 ] label [ - 10 , 5 ] The name of the anchor is followed by a location [vertical, horizontal]. These are each in the range (0 - 1] and may be floating point numbers. It has an optional label offset [vertical, horizontal] that can be used to shift the location of the label relative to it's anchor point. This can be helpful to make the diagram clearer. annotation This allows the map to be annotated with explanations. This serves two purposes: adding a label to the map (possibly in multiple places) and providing data for the annotaions keyword. Note that if used in a livebook it may make more sense to provide the details in a markdown field outside of the map, annotation 1 [ [ 0.43 , 0.49 ] , [ 0.08 , 0.79 ] ] Standardising power allows Kettles to evolve faster annotation 2 [ 0.48 , 0.85 ] Hot water is obvious and well known annotation is followed by a label (assumed to be a single character, symbol or digit, which can't be [ ). This is followed either by one location in [visibility, evolution] format or a list of locations also in [visibility, evolution] format. These expect the values to be floats in the range (0,1]. This is followed by the text used for the annotations. annotations This provides the location to display the annotation details. Please find an unused section of the map to place these. If you can't find a suitable place consider putting the text in a markdown cell on the same livebook and skipping the annotations keyword. annotations [ 0.60 , 0.02 ] The location is a [visibility, evolution] pair. This expects the values to be floats in the range (0,1]. background This allows the background colour of the map to be specified. background grey background #001001 It will treat the supplied value as a colour. Be warned that the lines on the map are currently drawn in black so using a too dark background may reduce the utility of the map. component Defines the basic items that the Wardley Map is built out of. It's only limited by your imagination as to what these mean! component Cup of Tea [ 0.79 , 0.61 ] label [ 19 , - 4 ] component Cup [ 0.73 , 0.78 ] It has a name, followed by a location in a [visibility, evolution] pair. This expects the values to be floats in the range (0, 1]. Note that a component name cannot include a zero if it needs to evolve. It has an optional label offset [vertical, horizontal] that can be used to shift the location of the label relative to it's component point. This can be helpful to make the diagram clearer. evolve This represents the movement of a component (typically) along the evolution axis. This represents the main form of movement on a Wardley Map. You need to define a component before evolving it or it will not render. component Kettle [ 0.43 , 0.35 ] label [ - 57 , 4 ] evolve Kettle 0.62 label [ 16 , 7 ] component Power [ 0.1 , 0.7 ] label [ - 27 , 20 ] evolve Power [ 0.1 , 0.89 ] label [ - 12 , 21 ] B There are two forms of evolve. One has the new evolution axis value and will inherit the value from the base component. The second matches the component syntax. Either version may have a label in the same format as the component. You are limited to one evolution per component per diagram. evolution This allows the labels on the horizontal axis to be replaced (or suppressed). evolution evolution First -&gt; Second -&gt; Third -&gt; Fourth evolution Novel -&gt; Emerging -&gt; Good -&gt; Best The order within the evolution defines the order shown. It is possible to miss a section out. Only the last evolution keyword in the spec will be applied. group Draws an ellipse on the background of the Wardley Map. Intended to be used to group components together. group first [ 0.605 , 0.85 , 20 , 50 ] yellow black group first [ 0.605 , 0.85 , 20 , 50 ] yellow The name is unique within the spec. The list of numbers is [visibility, evolution, vertical radius, horizontal radius]. Visibility and evolution are in the range (0, 1]. The radii are specified in pixels and must be an integer. The next field is the fill colour for the group. The last field is the border colour. If not specified it will default to the fill colour. Again be careful with the colours as these can obscure the lines. height This allows the height of the rendered image to be specified in pixels. This is optional and will be defaulted to 400 height 800 Again only the last use of this keyword will be applied. Please note that offsets are not relative to the size of the image so you may need to adjust them if you change the height or width. id This allows the id of the svg used for this Wardley Map to be specified. id myId This is entirely optional. note This allows free text to be added to the diagram for clarity. note + a generic note appeared [ 0.23 , 0.33 ] The + is purely conventional for Wardley Maps and may be ignored. The location [visibility, evolution] are both in the range (0, 1]. This describes where to draw the note. padding This allows the padding spacing around the diagram to be controlled. This is an integer value and is optional. It will default to 20 pixels. It's the same value used for top, bottom, left and right. padding 21 style This allows the style of the wardley map to be defined. style style wardley This is an optional field. If specified it will suppress the white background drawn for all text fields. If set to wardley it attempts to replicate the linear fill used by Simon Wardley for his maps. Currently the other values defined by onlinewardleymaps.com are not implemented. title This allows the map to be given a title. This is optional. title Tea Shop Only the last entry of this keyword will be used if repeated. width This allows the width of the rendered image to be specified in pixels. This is optional and will be defaulted to 800 width 400 Again only the last use of this keyword will be applied.","ref":"syntax.html#keywords","title":"Syntax of the Kino Wardley Map - Keywords","type":"extras"},{"doc":"There are two kinds of relationships. If they are not rendering please check that the names are spelt correctly. It requires an exact match. Link first name -&gt; second name This will draw a line between the two attached items and any evolved items of either component. Flow first name + &lt;&gt; second name This will draw a highlighted line between the two components. It does not follow to evolved items.","ref":"syntax.html#relationships","title":"Syntax of the Kino Wardley Map - Relationships","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#pending","title":"Changelog - Pending","type":"extras"},{"doc":"Adding style wardley diverging from onlinewardleymaps, adding a group This is a typical group: group first [ 0.605 , 0.85 , 20 , 50 ] yellow black The idea is that you can add ovals with various colours to group things together. Overlapping ovals (without a distinct border) should be able to create any required grouping. Added some documentation.","ref":"changelog.html#0-6-0","title":"Changelog - [0.6.0]","type":"extras"},{"doc":"Now supports title Also supports note Now has annotations and the annotation details","ref":"changelog.html#0-5-0","title":"Changelog - [0.5.0]","type":"extras"},{"doc":"Now all existing components are compatible with onlinewardleymaps syntax","ref":"changelog.html#0-4-1","title":"Changelog - [0.4.1]","type":"extras"},{"doc":"Added unit tests Added a changelog Added the ability to define offsets as per onlinewardleymap.com This allows things like: component Kettle [0.43, 0.35] label [-57, 4] I have not yet solved the evolve parsing. Added alternative axis. KinoWardley.Output . new ( &quot;&quot;&quot; id myid8 height 400 width 800 title Tea Shop anchor Business [0.95, 0.63] anchor Public [0.95, 0.78] component Cup of Tea [0.79, 0.61] label [19, -4] component Cup [0.73, 0.78] component Tea [0.63, 0.81] component Hot Water [0.52, 0.80] component Water [0.38, 0.82] component Kettle [0.43, 0.35] label [-57, 4] evolve Kettle [0.43, 0.62] label [16, 7] component Power [0.1, 0.7] label [-27, 20] evolve Power [0.1, 0.89] label [-12, 21] Business-&gt;Cup of Tea Public-&gt;Cup of Tea Cup of Tea-&gt;Cup Cup of Tea-&gt;Tea Cup of Tea-&gt;Hot Water Hot Water-&gt;Water Hot Water-&gt;Kettle Kettle-&gt;Power evolution Experiment-&gt;Prototype-&gt;Production-&gt;Product &quot;&quot;&quot; )","ref":"changelog.html#0-4-0","title":"Changelog - [0.4.0]","type":"extras"},{"doc":"Improved parsing via regex. Internally split the js file out of the ex file.","ref":"changelog.html#0-3-0-2022-09-03","title":"Changelog - [0.3.0] - 2022-09-03","type":"extras"}]